package com.caimei.module.base.entity.bo;

import com.caimei.module.base.entity.vo.FloorContentVo;
import com.caimei.module.base.entity.vo.FloorImageVo;
import lombok.Data;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

/**
 * 页面楼层
 *
 * @author : Charles
 * @date : 2020/6/22
 */
@Data
public class PageFloor implements Serializable {
    private Integer id;
    private Integer type;
    private String title;
    private String detail;
    private String link;
    /**
     * 楼层相关商品图片
     */
    private List<FloorImageVo> floorImageList;
    private List<PageFloor> subFloors;
    private List<ImageLink> floorData;
    /**
     * 链接类型 -1未知类型 1二级页面 2项目仪器 3直播页面 4自由页面 5商品详情 6项目仪器详情
     * 7供应商主页 8专题活动页 9二手市场介绍 10二手商品列表 11二手商品发布 12商品搜索 13信息详情
     * 14品牌招商介绍页 15维修保养介绍页 16首页 17注册页 18信息中心 19供应商列表
     */
    private Integer linkType;
    /**
     * 链接包含的参数
     */
    private Map<String, Object> linkParam;

    /**
     * 楼层内容模板
     */
    private FloorContentVo floorContent;

    /**
     * 前端pc控制查看更多
     */
    private Boolean isPageMore = false;

    private static final long serialVersionUID = 1L;
}
