package com.caimei.module.product.dao;

import com.caimei.module.base.entity.po.CmBrand;
import com.caimei.module.base.entity.po.SeconHandProduct;
import com.caimei.module.base.entity.vo.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2020/3/25
 */
@Mapper
public interface ProductModuleDao {
    List<ProductVo> getProductsByTypeId(@Param("bigTypeIDList") List<Integer> bigTypeIDList, @Param("smallTypeIDList") List<Integer> smallTypeIDList, @Param("tinyTypeIDList") List<Integer> tinyTypeIDList, @Param("sortType") Integer sortType);

    List<SearchHistoryVo> getSearchHistoryList(Integer userId);

    Long getSearchHistoryIdByWord(String searchWord);

    void updateSearchHistoryById(SearchHistoryVo historyRecord);

    void insertSearchHistory(SearchHistoryVo historyRecord);

    void deleteSearchHistoryByUserId(Integer userId);

    List<ProductVo> searchProduct(String searchWord);

    ProductVo findProductById(Integer productID);

    ProductVo findProductUnlimited(Integer productID);

    List<ProductImageVo> findProductImage(Integer productID);

    List<String> findImageByProductId(Integer productID);

    List<String> findProductImageString(Integer productID);

    ShopVo findProductShopById(Integer shopID);

    ProductDetailVo findProductDetailById(Integer productID);

    List<BigtypeVo> getBigType(@Param("typeSort") String typeSort, @Param("source") String source);

    List<SmalltypeVo> getSmallType(@Param("bigTypeID") Integer bigTypeID, @Param("source") String source);

    List<TinytypeVo> getTinytype(@Param("smallTypeID") Integer smallTypeID, @Param("source") String source);

    LadderPriceVo findLowerLadderPrice(Integer productID);

    List<LadderPriceVo> findLadderPrice(Integer productID);

    List<ProductVo> getProductsByPreferredFlag(Integer preferredFlag);

    List<Integer> getRecommendIds(Integer productID);

    List<ProductVo> getRecommendByIds(@Param("productIDs") List<Integer> productIDs);

    List<ProductVo> getDeFaultRecommend(Integer tinyTypeID);

    void deleteAllSearchHistory(Integer userId);

    AddressVo getAddressInfo(Integer townId);

    void saveSencondHandProduct(SeconHandProduct seconHandProduct);

    List<SeconHandProduct> getSeconHandProductList(SeconHandProduct seconHandProduct);

    List<SeconHandProduct> getSeconHandProductByLimit(String secondHandType);

    SeconHandProduct getSencondHandProductDetail(Integer productId);

    List<CmBrand> getBrandList();

    void updateViewingNum(SeconHandProduct sencondHandProductDetail);

    List<SeconHandProduct> getSecondHandProductRecommend(Integer productId);

    List<SeconHandProduct>  getOrderSecondHandProductList(@Param("searchKeyword")String searchKeyword, @Param("secondHandType")String secondHandType, @Param("instrumentType")String instrumentType);

    void updatSecondHnadproductSold(Integer productID);

    List<SeconHandProduct> getSecondHandProductListByMaturity(@Param("beforeDays")Date beforeDays);

    void updateProductValidFlag(@Param("productID")Integer productID, @Param("validFlag")String validFlag);

    String findTypeName(Integer tinyTypeID);

    BrandVo getBrand(Integer brandID);

    Integer findProductNormalNumById(Integer shopID);
}
